SystemOrganization addCategory: #ProxiesTests!

Object subclass: #ClassWith1Var
	instanceVariableNames: 'var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/2/2010 19:26'!
foo
	^ 'foo'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomething'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1
	^ var1! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1: anObject
	var1 := anObject! !

Object subclass: #ClassWith2Var
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
foo
	^ 'foo'! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1
	^ var1! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1: anObject
	var1 := anObject! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2
	^ var2! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2: anObject
	var2 := anObject! !

TestCase subclass: #ClassProxyFileOutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:53'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"When seding any message that is not understood to the proxy, the original class is restored"
	ClassWith1Var format.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapSimple
	| inst proxy |
	"This is the simplest test that does the less assert as possible."
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	proxy := ClassProxyFileOut new.
	proxy become: ClassWith1Var.
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
! !

TestCase subclass: #ClassProxyInstVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:10'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyInstVar new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyInstVar.
	self assert: inst class class name =  #ClassProxyInstVar.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"When seding any message that is not understood to the proxy, the original class is restored"
	ClassWith1Var format.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyInstVar.

! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:09'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyInstVar new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyInstVar.
	self assert: inst class class name =  #ClassProxyInstVar.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyInstVar.

! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:08'!
testClassSwapSimple
	| inst proxy |
	"This is the simplest test that does the less assert as possible."
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	proxy := ClassProxyInstVar new.
	proxy become: ClassWith1Var.
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
! !

TestCase subclass: #ObjectProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/16/2010 21:35'!
XXXXtestOneClassObjectsInner
		
	| b a proxy |
	
	b := ClassWith2Var. 
	a := ClassWith1Var new var1: b.
	
	"We put a proxy and become for B."
	ObjectSwapper new swap: b.
	Transcript show: 'antes';cr.
	self assert: a var1 name = AClassProxy name. 
	Transcript show: 'desp';cr.
	a var1 new class.
	self assert: a var1 new class = ClassWith2Var.
	Transcript show: 'mas desp';cr.
	self assert: a var1 class = ClassWith2Var. 
	Transcript show: 'ree desp';cr.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 17:10'!
testAllNomralObjectsAllInner
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	Smalltalk garbageCollect.
	initialInstances := ClassWith1Var instanceCount. 
	d := c := nil.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: b.
	
	Smalltalk garbageCollect.
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D an C should be garbage collected"
	self assert: finalInstances = (initialInstances - 2). 
	

	self assert: a var1 = b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	self assert:  ClassWith1Var instanceCount = initialInstances.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 9/30/2010 10:37'!
testAllNomralObjectsInnerAndShared
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	Smalltalk garbageCollect.
	initialInstances := ClassWith1Var instanceCount. 
	d :=  nil.
	"We only nil D. C is still pointing, thus, it is a shared object."
	
	"We put a proxy and become for B."
	ObjectSwapper new swap: b.
	
	Smalltalk garbageCollect.
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D (C will not) should be garbage collected"
	self assert: finalInstances = (initialInstances - 1). 
	

	self assert: a var1 = b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	"We cannot get duplicates of C."
	self assert:  ClassWith1Var instanceCount = initialInstances.
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:39'!
testOneSingleObject
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	
	[proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 'Hello').
	self assert: (anObject class name = 'Hello' class name).
	] ensure: [anObject isByteString]! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:33'!
testOneSingleObjectProxyUndetstandsMessage
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:32'!
testOneSingleObjectSpecialBytecodes
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject class.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !
